
SUFFIXES += .nice
CLEANFILES += *.nice.ice *.nice.cc *.nice.tmp
CLEANFILES += $(patsubst %.nice, %.nice.cc, $(filter %.nice, $(SOURCES)))
CLEANFILES += $(patsubst %.nice, %.ice, $(filter %.nice, $(SOURCES)))
CLEANFILES += $(patsubst %.nice, %.cc, $(filter %.nice, $(SOURCES)))
CLEANFILES += $(patsubst %.nice, %.h, $(filter %.nice, $(SOURCES)))

nice_build_files = $(patsubst %.nice, %.cc, $(filter %.nice, $(SOURCES)))
$(nice_build_files): $(NICE_CC_DATADIR)/Nice/PropertyTemplate.n2c $(NICE_CC)

BUILT_SOURCES += $(patsubst %.nice, %.cc, $(filter %.nice, $(SOURCES)))

NICEIT=if ! $(NICE_CC) $(NICE_CC_DATADIR)/Nice/PropertyTemplate.n2c $(srcdir) $(subst $(srcdir),,$*) $(NICE_SWIGIN); then \
          exit -1; \
    elif ! $(ICE_SLICE2CPP) $(SLICE_INC) $(SLICE_COPT) --source-ext=cc --header-ext=h $*.ice; then \
          exit -1; \
    else \
      cat $*.nice.cc >> $*.cc; \
      rm $*.ice; \
    fi

AM_V_NICE = $(am__v_NICE_$(V))
am__v_NICE_ = $(am__v_NICE_$(AM_DEFAULT_VERBOSITY))
am__v_NICE_0 = @echo "  NICE  " $@; $(NICEIT)
am__v_NICE_1 = $(NICEIT)

.nice.cc:
	$(AM_V_NICE)

clean-local-nice:


all-local-nice: 
